diff -uNrd ircd-hybrid-7.0/src/client.c anynet-3.0/src/client.c
--- ircd-hybrid-7.0/src/client.c	Sun Mar  2 02:30:54 2003
+++ anynet-3.0/src/client.c	Mon Feb  2 14:09:23 2004
@@ -399,7 +399,7 @@
 {               
   struct Client *client_p;          /* current local client_p being examined */
   struct ConfItem *aconf = NULL;
-  char *reason;                /* pointer to reason string */
+  char reason[IRCD_BUFSIZE];        /* rain - so we can prepend K/G/D-lined */
   dlink_node *ptr, *next_ptr;
  
   DLINK_FOREACH_SAFE(ptr, next_ptr, lclient_list.head)
@@ -424,10 +424,11 @@
       sendto_realops_flags(FLAGS_ALL, L_ALL,"DLINE active for %s",
 			   get_client_name(client_p, HIDE_IP));
       
+      /* rain - using reason buffer now */
       if (ConfigFileEntry.kline_with_connection_closed &&
 	  ConfigFileEntry.kline_with_reason)
       {
-	reason = "Connection closed";
+        ircsprintf(reason, "Connection closed");
 
 	if(IsPerson(client_p))
 	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
@@ -439,11 +440,11 @@
       else
       {
 	if(ConfigFileEntry.kline_with_connection_closed)
-	  reason = "Connection closed";
+	  ircsprintf(reason, "Connection closed");
 	else if(ConfigFileEntry.kline_with_reason && aconf->passwd)
-	  reason = aconf->passwd;
+	  ircsprintf(reason, "%s: %s", "D-lined", aconf->passwd);
 	else
-	  reason = "D-lined";
+	  ircsprintf(reason, "D-lined");
 
 	if(IsPerson(client_p))
 	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
@@ -480,10 +481,11 @@
 	sendto_realops_flags(FLAGS_ALL, L_ALL, "GLINE active for %s",
 			     get_client_name(client_p, HIDE_IP));
 			    
+        /* rain - using reason buffer now */
 	if(ConfigFileEntry.kline_with_connection_closed &&
 	   ConfigFileEntry.kline_with_reason)
 	{
-	  reason = "Connection closed";
+	  ircsprintf(reason, "Connection closed");
 
 	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name,
@@ -492,11 +494,11 @@
 	else 
 	{
 	  if(ConfigFileEntry.kline_with_connection_closed)
-	    reason = "Connection closed";
+	    ircsprintf(reason, "Connection closed");
 	  else if(ConfigFileEntry.kline_with_reason && aconf->passwd)
-	    reason = aconf->passwd;
+	    ircsprintf(reason, "%s: %s", "G-lined", aconf->passwd);
 	  else
-	    reason = "G-lined";
+	    ircsprintf(reason, "G-lined");
 
 	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name, reason);
@@ -520,10 +522,11 @@
 	sendto_realops_flags(FLAGS_ALL, L_ALL, "KLINE active for %s",
 			     get_client_name(client_p, HIDE_IP));
 	
+        /* rain - using reason buffer now */
 	if(ConfigFileEntry.kline_with_connection_closed &&
 	   ConfigFileEntry.kline_with_reason)
 	{
-	  reason = "Connection closed";
+	  ircsprintf(reason, "Connection closed");
 
 	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name, 
@@ -532,11 +535,11 @@
 	else
 	{
 	  if(ConfigFileEntry.kline_with_connection_closed)
-	    reason = "Connection closed";
+	    ircsprintf(reason, "Connection closed");
 	  else if(ConfigFileEntry.kline_with_reason && aconf->passwd)
-	    reason = aconf->passwd;
+	    ircsprintf(reason, "%s: %s", "K-lined", aconf->passwd);
 	  else
-	    reason = "K-lined";
+	    ircsprintf(reason, "K-lined");
 
 	  sendto_one(client_p, form_str(ERR_YOUREBANNEDCREEP),
 		     me.name, client_p->name, reason);
@@ -1451,7 +1454,8 @@
                            source_p->name, (int)(CurrentTime - source_p->firsttime),
                            source_p->localClient->sendK,
                            source_p->localClient->receiveK);
-      ilog(L_NOTICE, "%s was connected for %d seconds.  %d/%d sendK/recvK.",
+      /* rain - use %ld for time_t in format */
+      ilog(L_NOTICE, "%s was connected for %ld seconds.  %d/%d sendK/recvK.",
            source_p->name, CurrentTime - source_p->firsttime, 
            source_p->localClient->sendK, source_p->localClient->receiveK);
     }
@@ -1472,8 +1476,9 @@
  */
 
 /* XXX one common Client list now */
+/* rain - made argument type a u_long instead */
 void
-count_local_client_memory(int *count, int *local_client_memory_used)
+count_local_client_memory(int *count, u_long *local_client_memory_used)
 {
   *count = local_client_count;
   *local_client_memory_used = local_client_count *
@@ -1483,8 +1488,9 @@
 /*
  * Count up remote client memory
  */
+/* rain - made argument type a u_long instead */
 void
-count_remote_client_memory(int *count, int *remote_client_memory_used)
+count_remote_client_memory(int *count, u_long *remote_client_memory_used)
 {
   *count = remote_client_count;
   *remote_client_memory_used = remote_client_count * sizeof(struct Client);
diff -uNrd ircd-hybrid-7.0/src/dynlink.c anynet-3.0/src/dynlink.c
--- ircd-hybrid-7.0/src/dynlink.c	Tue Dec  3 21:42:21 2002
+++ anynet-3.0/src/dynlink.c	Mon Feb  2 02:31:20 2004
@@ -54,7 +54,8 @@
 /*
  * Fake dlfunc(3) if we don't have it, cause it's happy.
  */
-typedef void (*__function_p)(void);
+/* rain - moved typedef to header */
+/* typedef void (*__function_p)(void); */
 
 __function_p
 dlfunc(void *myHandle, const char *functionName)
@@ -227,7 +228,8 @@
 #endif
 
   MyFree(modlist[modindex]->name);
-  memcpy( &modlist[modindex], &modlist[modindex+1],
+  /* rain - changed memcpy to memmove because arguments overlap */
+  memmove( &modlist[modindex], &modlist[modindex+1],
           sizeof(struct module) * ((num_mods-1) - modindex) );
 
   if(num_mods != 0)
@@ -346,7 +348,8 @@
       sendto_realops_flags(FLAGS_ALL, L_ALL,
                         "Module %s [version: %s] loaded at 0x%lx",
                         mod_basename, ver, (unsigned long)tmpptr);
-       ilog (L_WARN, "Module %s [version: %s] loaded at 0x%x",
+       /* rain - changed 0x%x to more correct %p */
+       ilog (L_WARN, "Module %s [version: %s] loaded at %p",
             mod_basename, ver, tmpptr);
     }
   MyFree (mod_basename);
diff -uNrd ircd-hybrid-7.0/src/hook.c anynet-3.0/src/hook.c
--- ircd-hybrid-7.0/src/hook.c	Wed Oct 30 22:12:30 2002
+++ anynet-3.0/src/hook.c	Sat Jan 31 19:38:01 2004
@@ -45,6 +45,10 @@
         hook_add_event("iorecvctrl");
 #endif
 	hook_add_event("burst_channel");
+	/* rain - extended ISUPPORT */
+	hook_add_event("update_isupport");
+	/* rain - add a general netburst hook */
+	hook_add_event("burst");
 }
 
 static hook *
diff -uNrd ircd-hybrid-7.0/src/irc_string.c anynet-3.0/src/irc_string.c
--- ircd-hybrid-7.0/src/irc_string.c	Fri Apr  4 20:37:57 2003
+++ anynet-3.0/src/irc_string.c	Mon Feb  2 09:02:13 2004
@@ -598,7 +598,8 @@
 #ifdef IPV6
 	case AF_INET6:
 		/* Somebody might have passed as an IPv4 address this is sick but it works */
-		if(inet_pton4(src, dst))
+		/* rain - made check == 1 since -1 is an error case */
+		if(inet_pton4(src, dst) == 1)
 		{
 			char tmp[HOSTIPLEN];
 			ircsprintf(tmp, "::ffff:%s", src);
diff -uNrd ircd-hybrid-7.0/src/ircd.c anynet-3.0/src/ircd.c
--- ircd-hybrid-7.0/src/ircd.c	Thu May 29 01:13:26 2003
+++ anynet-3.0/src/ircd.c	Mon Feb  2 05:22:56 2004
@@ -71,6 +71,13 @@
 #include "hook.h"
 #include "ircd_getopt.h"
 #include "balloc.h"
+#ifdef SSL_CLIENT_SUPPORT
+/* rain - for SSL client support */
+#include "ssl_client.h"
+#endif
+/* rain - for extended ISUPPORT numeric support */
+#include "isupport.h"
+
 /*
  * Try and find the correct name to use with getrlimit() for setting the max.
  * number of files allowed to be open by this process.
@@ -585,7 +592,8 @@
   ConfigFileEntry.configfile = CPATH;   /* Server configuration file */
   ConfigFileEntry.klinefile = KPATH;    /* Server kline file */
   ConfigFileEntry.dlinefile = DLPATH;   /* dline file */
-  ConfigFileEntry.glinefile = GPATH;    /* gline log file */
+/* rain - no longer relevant */
+/*  ConfigFileEntry.glinefile = GPATH; */   /* gline log file */
 
   myargv = argv;
   umask(077);                /* better safe than sorry --SRB */
@@ -635,6 +643,10 @@
   initBlockHeap();
   init_dlink_nodes();
   initialize_message_files();
+#ifdef SSL_CLIENT_SUPPORT
+  /* rain - initialize the SSL context */
+  SSLC_CTX_init();
+#endif
   linebuf_init();       /* set up some linebuf stuff to control paging */
   init_hash();
   id_init();
@@ -649,6 +661,7 @@
   initwhowas();
   init_stats();
   init_hooks();
+
   load_all_modules(1);
 #ifndef STATIC_MODULES
   load_core_modules(1);
@@ -732,6 +745,11 @@
   
   check_class();
   write_pidfile(pidFileName);
+
+/* rain - initialize extended ISUPPORT code */
+  isupport_init();
+  /* rain - give extended ISUPPORT code our starting configuration */
+  hook_call_event("update_isupport", ISUP_NO_PROPAGATE);
   
   ilog(L_NOTICE, "Server Ready");
   
@@ -761,6 +779,14 @@
 
   ServerRunning = 1;
   io_loop();
+
+#ifdef SSL_CLIENT_SUPPORT
+  /* rain - deinitialize SSL context */
+  SSLC_CTX_deinit();
+#endif
+  /* rain - deinitialize extended ISUPPORT code */
+  isupport_deinit();
+
   return 0;
 }
 
diff -uNrd ircd-hybrid-7.0/src/ircd_lexer.l anynet-3.0/src/ircd_lexer.l
--- ircd-hybrid-7.0/src/ircd_lexer.l	Wed Oct 30 12:44:56 2002
+++ anynet-3.0/src/ircd_lexer.l	Wed Feb  4 12:08:46 2004
@@ -74,6 +74,12 @@
 qstring   \"[^\"\n]*[\"\n]
 include   \.include{ws}(\<.*\>|\".*\")
 
+/*
+ * rain - these are no longer relevant, removed
+gline_log       { return GLINE_LOG; }
+gline_time      { return GLINE_TIME; }
+ */
+
 %%
 {include}       { cinclude(); }
 "/*"	        { ccomment(); }
@@ -176,8 +182,6 @@
 general		{ return GENERAL; }
 gline		{ return GLINE; }
 gline_exempt    { return GLINE_EXEMPT; }
-gline_log       { return GLINE_LOG; }
-gline_time      { return GLINE_TIME; }
 global_kill	{ return GLOBAL_KILL; }
 have_ident	{ return HAVE_IDENT; }
 havent_read_conf { return HAVENT_READ_CONF; }
@@ -254,6 +258,9 @@
 silent          { return SILENT; }
 spoof		{ return SPOOF; }
 spoof_notice	{ return SPOOF_NOTICE; }
+ssl		{ return SSL_PORT; /* rain - SSL client support */}
+ssl_cert_file	{ return SSL_CERT_FILE; /* rain - SSL client support */ }
+ssl_private_key_file { return SSL_PRIVATE_KEY_FILE; /* rain - SSL client support */ }
 true_no_oper_flood { return TRUE_NO_OPER_FLOOD; }
 unkline		{ return UNKLINE; }
 use_anonops	{ return USE_ANONOPS; }
@@ -388,6 +395,8 @@
     {
       while ((c = input()) == '*');
       if (c == '/') break;
+      /* rain - fix line counter */
+      if (c == '\n') lineno++;
     }
     if (c == EOF)
     {
diff -uNrd ircd-hybrid-7.0/src/ircd_parser.y anynet-3.0/src/ircd_parser.y
--- ircd-hybrid-7.0/src/ircd_parser.y	Tue Nov 12 08:45:42 2002
+++ anynet-3.0/src/ircd_parser.y	Wed Feb  4 12:09:02 2004
@@ -225,6 +225,9 @@
 %token  SILENT
 %token  SPOOF
 %token  SPOOF_NOTICE
+%token  SSL_CERT_FILE
+%token  SSL_PORT
+%token  SSL_PRIVATE_KEY_FILE
 %token  STATS_I_OPER_ONLY
 %token  STATS_K_OPER_ONLY
 %token  STATS_O_OPER_ONLY
@@ -409,7 +412,8 @@
                         serverinfo_network_name | serverinfo_network_desc |
                         serverinfo_max_clients | 
                         serverinfo_rsa_private_key_file | serverinfo_vhost6 |
-                        serverinfo_max_buffer | 
+                        serverinfo_max_buffer | serverinfo_ssl_cert_file |
+                        serverinfo_ssl_private_key_file |
 			error;
 
 serverinfo_rsa_private_key_file: RSA_PRIVATE_KEY_FILE '=' QSTRING ';'
@@ -580,6 +584,20 @@
       ServerInfo.hub = 0;
   } ;
 
+serverinfo_ssl_cert_file: SSL_CERT_FILE '=' QSTRING ';'
+  {
+#ifdef SSL_CLIENT_SUPPORT /* rain - SSL client support */
+    SSLC_CertificateFile(yylval.string);
+#endif
+  };
+
+serverinfo_ssl_private_key_file: SSL_PRIVATE_KEY_FILE '=' QSTRING ';'
+  {
+#ifdef SSL_CLIENT_SUPPORT /* rain - SSL client support */
+    SSLC_PrivateKeyFile(yylval.string);
+#endif
+  };
+
 
 /***************************************************************************
  * admin section
@@ -620,8 +638,9 @@
 logging_items:          logging_items logging_item |
                         logging_item ;
 
+/* rain - removed logging_gline_log */
 logging_item:           logging_path | logging_oper_log |
-                        logging_gline_log | logging_log_level |
+                        logging_log_level |
 			error;
 
 logging_path:           T_LOGPATH '=' QSTRING ';' 
@@ -632,9 +651,12 @@
                         {
                         };
 
+/*
+rain - no longer relevant
 logging_gline_log:	GLINE_LOG '=' QSTRING ';'
                         {
                         };
+*/
 
 logging_log_level:     LOG_LEVEL '=' T_L_CRIT ';'
   { set_log_level(L_CRIT); }
@@ -969,7 +991,8 @@
 listen_items:   listen_items listen_item |
                 listen_item;
 
-listen_item:    listen_port | listen_address | listen_host | error;
+listen_item:    listen_port | listen_address | listen_host |
+                error;
 
 listen_port: PORT '=' port_items ';' ;
 
@@ -977,13 +1000,27 @@
 
 port_item: NUMBER
 {
-  add_listener($1, listener_address);
+  /* rain - added listener_ssl param for SSL client support */
+  add_listener($1, listener_address, 0);
+} | NUMBER SSL_PORT
+{
+  /* rain - added listener_ssl param for SSL client support */
+  add_listener($1, listener_address, 1);
 } | NUMBER TWODOTS NUMBER
 {
+  /* rain - added listener_ssl param for SSL client support */
   int i;
   for (i = $1; i <= $3; i++)
 	{
-	  add_listener(i, listener_address);
+	  add_listener(i, listener_address, 0);
+	}
+} | NUMBER TWODOTS NUMBER SSL_PORT
+{
+  /* rain - added listener_ssl param for SSL client support */
+  int i;
+  for (i = $1; i <= $3; i++)
+	{
+	  add_listener(i, listener_address, 1);
 	}
 };
 
@@ -1943,6 +1980,7 @@
 general_items:      general_items general_item |
                     general_item;
 
+/* rain - removed general_gline_time */
 general_item:       general_failed_oper_notice |
                     general_anti_nick_flood | general_max_nick_time |
                     general_max_nick_changes | general_max_accept |
@@ -1959,7 +1997,7 @@
                     general_true_no_oper_flood |
                     general_iauth_server |
                     general_iauth_port |
-                    general_glines | general_gline_time |
+                    general_glines |
                     general_idletime |
                     general_maximum_links |
                     general_message_locale | general_client_exit |
@@ -2234,10 +2272,12 @@
     putenv(langenv);
   } ;
 
+/* rain - no longer relevant
 general_gline_time: GLINE_TIME '=' timespec ';'
   {
     ConfigFileEntry.gline_time = $3;
   } ;
+*/
 
 general_idletime: IDLETIME '=' timespec ';'
   {
diff -uNrd ircd-hybrid-7.0/src/ircdauth.c anynet-3.0/src/ircdauth.c
--- ircd-hybrid-7.0/src/ircdauth.c	Tue Feb  4 00:30:50 2003
+++ anynet-3.0/src/ircdauth.c	Thu Jan 22 12:16:41 2004
@@ -108,10 +108,12 @@
   /*
    * bingo - this is blocking :(
    */
-  ilog(L_ERROR, "looking up: %s\n", iAuth.hostname);
+  /* rain - removed extraneous \n */
+  ilog(L_ERROR, "looking up: %s", iAuth.hostname);
 	if ((hostptr = gethostbyname(iAuth.hostname)) == NULL)
 	{
-    ilog(L_ERROR, "unsuccessful lookup\n");
+    /* rain - removed extraneous \n */
+    ilog(L_ERROR, "unsuccessful lookup");
 		ilog(L_ERROR,
 			"Unable to connect to IAuth server: Unknown host");
 
diff -uNrd ircd-hybrid-7.0/src/isupport.c anynet-3.0/src/isupport.c
--- ircd-hybrid-7.0/src/isupport.c	Wed Dec 31 19:00:00 1969
+++ anynet-3.0/src/isupport.c	Wed Feb  4 12:57:44 2004
@@ -0,0 +1,372 @@
+/*
+ * isupport.c: Extended ISUPPORT numeric support
+ *
+ * Copyright (c) 2004  Ben Winslow.
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ * 
+ * 1. Redistributions of source code must retain the above copyright notice,
+ *    this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright notice,
+ *    the above paragraph (the one permitting redistribution), this list of
+ *    conditions and the following disclaimer in the documentation and/or
+ *    other materials provided with the distribution.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
+ * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $Id$
+ */
+
+#include "config.h"
+#include "stdinc.h"
+#include "event.h"
+#include "ircd_defs.h"
+#include "numeric.h"
+#include "client.h"
+#include "ircd.h"
+#include "supported.h" /* for CASEMAP */
+#include "s_conf.h"
+#include "channel_mode.h"
+#include "s_log.h"
+#include "hook.h"
+#include "send.h"
+#ifdef SSL_CLIENT_SUPPORT
+#include "ssl_client.h"
+#endif
+#include "isupport.h"
+
+static int isupport_add_token(char *, struct isupport_s *, int, int *);
+static void isupport_build(int);
+static int isupport_update(int);
+
+static struct isupport_s isup;
+
+void isupport_init(void)
+{
+	memset(&isup, 0, sizeof(isup));
+	DupString(isup.old_netname, NETWORK_NAME_DEFAULT);
+
+	hook_add_hook("update_isupport", (hookfn *)isupport_update);
+}
+
+void isupport_send(struct Client *client_p)
+{
+	int x;
+
+	for (x = 0; x < isup.lines; x++) {
+		sendto_one(client_p, form_str(RPL_ISUPPORT), me.name,
+			client_p->name, isup.line[x]);
+	}
+}
+
+void isupport_deinit(void)
+{
+	if (isup.old_netname != NULL)
+		MyFree(isup.old_netname);
+}
+
+/* hook function */
+static int isupport_update(int send_changed)
+{
+	isupport_build(send_changed);
+	
+	return 0;
+}
+
+static int isupport_add_token(char *buf, struct isupport_s *is, int maxlen, int *toknum)
+{
+	if (is == NULL || toknum == NULL || is->lines > MAX_ISUPPORT_LINES)
+		return -1;
+
+	/*
+	 * if the token won't fit on this line, or we've hit the token
+	 * limit, advance to the next isupport line
+	 */
+	
+	if (strlen(is->line[is->lines]) + 1 + strlen(buf) > maxlen ||
+		*toknum >= 13) {
+		
+		is->lines++;
+		(*toknum) = 0;
+		
+		if (is->lines >= MAX_ISUPPORT_LINES) {
+			ilog(L_ERROR, "ISUPPORT reply too large -- Increase MAX_ISUPPORT_LINES");
+			return -1;
+		}
+	}
+	
+	/* add a space if this isn't the first token */
+	if (is->line[is->lines][0])
+		strcat(is->line[is->lines], " ");
+
+	/* add the token */
+	strcat(is->line[is->lines], buf);
+	
+	(*toknum)++;
+
+	return 0;
+}
+
+static void isupport_build(int send_changed)
+{
+	int maxlen, tok = 0, tok_changed = 0, x;
+	char curtoken[BUFSIZE];
+	struct isupport_s changed;
+	dlink_node *dlnode, *dlnode_next;
+	struct Client *client_p;
+
+	for (x = 0; x < MAX_ISUPPORT_LINES; x++)
+		memset(isup.line[x], 0, sizeof(isup.line[x]));
+	isup.lines = 0;
+
+	memset(&changed, 0, sizeof(changed));
+	
+	sprintf(curtoken, form_str(RPL_ISUPPORT), me.name, "", "");
+	maxlen = BUFSIZE - (strlen(curtoken) + NICKLEN + 3);
+	
+	/* rain - ISUPPORT tokens from draft-brocklesby-irc-isupport-03 */
+
+	/* *** ISUPPORT TOKEN: STD */
+	sprintf(curtoken, "STD=%s", ISUPPORT_STANDARD);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+
+	/* *** ISUPPORT TOKEN: CASEMAPPING */
+	sprintf(curtoken, "CASEMAPPING=%s", CASEMAP);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	
+	/* *** ISUPPORT TOKEN: CHANLIMIT */
+	sprintf(curtoken, "CHANLIMIT=%s:%d",
+		ConfigServerHide.disable_local_channels ? "#" : "#&",
+		ConfigChannel.max_chans_per_user);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+
+	if (ConfigServerHide.disable_local_channels !=
+		((isup.old_flags & ISUP_FLAG_NOLOCAL) ? 1 : 0) ||
+		ConfigChannel.max_chans_per_user != isup.old_maxchans) {
+		
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		
+		/* ISUP_FLAG_NOLOCAL set in CHANTYPES */
+		/* old_maxchans set in MAXCHANNELS */
+	}
+	
+	/* *** ISUPPORT TOKEN: CHANMODES */
+	sprintf(curtoken, "CHANMODES=b%s%s,k,l,imnpst%s",
+		ConfigChannel.use_except ? "e" : "",
+		ConfigChannel.use_invex ? "I" : "",
+		ConfigChannel.use_anonops ? "a" : "");
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	
+	if (ConfigChannel.use_except != !!(isup.old_flags & ISUP_FLAG_EXCEPTS) ||
+		(ConfigChannel.use_invex != !!(isup.old_flags & ISUP_FLAG_INVEX))) {
+		
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		
+		/* ISUP_FLAG_EXCEPTS set in EXCEPT */
+		/* ISUP_FLAG_INVEX set in INVEX */
+	}
+	
+	/* *** ISUPPORT TOKEN: MAXLIST */
+	sprintf(curtoken, "MAXLIST=b%s%s:%d",
+		ConfigChannel.use_except ? "e" : "",
+		ConfigChannel.use_invex ? "I" : "",
+		ConfigChannel.max_bans);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+
+	if (ConfigChannel.use_except != !!(isup.old_flags & ISUP_FLAG_EXCEPTS) ||
+		(ConfigChannel.use_invex != !!(isup.old_flags & ISUP_FLAG_INVEX)) ||
+		ConfigChannel.max_bans != isup.old_maxbans) {
+
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		/* ISUP_FLAG_EXCEPTS set in EXCEPT */
+		/* ISUP_FLAG_INVEX set in INVEX */
+		/* old_maxbans is set in MAXBANS */
+	}
+
+	/* *** ISUPPORT TOKEN: EXCEPTS */
+	if (ConfigChannel.use_except) {
+		isupport_add_token("EXCEPTS", &isup, maxlen, &tok);
+		if (!(isup.old_flags & ISUP_FLAG_EXCEPTS))
+			isupport_add_token("EXCEPTS", &changed, maxlen, &tok_changed);
+		isup.old_flags |= ISUP_FLAG_EXCEPTS;
+	} else {
+		if ((isup.old_flags & ISUP_FLAG_EXCEPTS))
+			isupport_add_token("-EXCEPTS", &changed, maxlen, &tok_changed);
+		isup.old_flags &= ~ISUP_FLAG_EXCEPTS;
+	}
+
+	/* *** ISUPPORT TOKEN: INVEX */
+	if (ConfigChannel.use_invex) {
+		isupport_add_token("INVEX", &isup, maxlen, &tok);
+		if (!(isup.old_flags & ISUP_FLAG_INVEX))
+			isupport_add_token("INVEX", &changed, maxlen, &tok_changed);
+		isup.old_flags |= ISUP_FLAG_INVEX;
+	} else {
+		if ((isup.old_flags & ISUP_FLAG_INVEX))
+			isupport_add_token("-INVEX", &changed, maxlen, &tok_changed);
+		isup.old_flags &= ~ISUP_FLAG_INVEX;
+	}
+	
+	/* *** ISUPPORT TOKEN: KICKLEN */
+	sprintf(curtoken, "KICKLEN=%d", TOPICLEN);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+
+	/* *** ISUPPORT TOKEN: MODES */
+	sprintf(curtoken, "MODES=%d", MAXMODEPARAMS);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+
+	/* *** ISUPPORT TOKEN: NETWORK */
+	sprintf(curtoken, "NETWORK=%s", ServerInfo.network_name);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	if (strcmp(ServerInfo.network_name, isup.old_netname)) {
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		MyFree(isup.old_netname);
+		DupString(isup.old_netname, ServerInfo.network_name);
+	}
+
+	/* *** ISUPPORT TOKEN: NICKLEN */
+	sprintf(curtoken, "NICKLEN=%d", NICKLEN - 1);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+
+	/* *** ISUPPORT TOKEN: PREFIX */
+	sprintf(curtoken, "PREFIX=%s",
+		ConfigChannel.use_halfops ? "(ohv)@%+" : "(ov)@+");
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+
+	/* *** ISUPPORT TOKEN: STATUSMSG */
+	sprintf(curtoken, "STATUSMSG=@%s+",
+		ConfigChannel.use_halfops ? "%" : "");
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	
+	/* *** ISUPPORT TOKEN: TARGMAX */
+	sprintf(curtoken, "TARGMAX=PRIVMSG:%d,NOTICE:%d,ACCEPT:,JOIN:,PART:",
+		ConfigFileEntry.max_targets, ConfigFileEntry.max_targets);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	if (ConfigFileEntry.max_targets != isup.old_maxtargets) {
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		isup.old_maxtargets = ConfigFileEntry.max_targets;
+	}
+
+	/* *** ISUPPORT TOKEN: TOPICLEN */	
+	sprintf(curtoken, "TOPICLEN=%d", TOPICLEN);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	
+#ifdef SSL_CLIENT_SUPPORT
+	/* *** ISUPPORT TOKEN: STARTTLS */
+	if ((ServerInfo.ssl_status & SSLC_STAT_STARTTLS_OK) == SSLC_STAT_STARTTLS_OK) {
+		isupport_add_token("STARTTLS", &isup, maxlen, &tok);
+		if (!(isup.old_flags & ISUP_FLAG_STARTTLS))
+			isupport_add_token("STARTTLS", &changed, maxlen, &tok_changed);
+		isup.old_flags |= ISUP_FLAG_STARTTLS;
+	} else {
+		if ((isup.old_flags & ISUP_FLAG_STARTTLS))
+			isupport_add_token("-STARTTLS", &changed, maxlen, &tok_changed);
+		isup.old_flags &= ~ISUP_FLAG_STARTTLS;
+	}
+#endif
+
+#if CHANNELLEN != 200
+	/* *** ISUPPORT TOKEN: CHANNELLEN */
+	sprintf(curtoken, "CHANNELLEN=%d", CHANNELLEN);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+#endif
+
+	/* *** ISUPPORT TOKEN: CHANTYPES */
+	/* rain - don't send CHANTYPES if it's default */
+	if (ConfigServerHide.disable_local_channels) {
+		isupport_add_token("CHANTYPES=#", &isup, maxlen, &tok);
+		if (!(isup.old_flags & ISUP_FLAG_NOLOCAL))
+			isupport_add_token("CHANTYPES=#", &changed, maxlen, &tok_changed);
+		isup.old_flags |= ISUP_FLAG_NOLOCAL;
+	} else {
+		if ((isup.old_flags & ISUP_FLAG_NOLOCAL))
+			isupport_add_token("-CHANTYPES", &changed, maxlen, &tok_changed);
+		isup.old_flags &= ~ISUP_FLAG_NOLOCAL;
+	}
+
+	/* *** ISUPPORT TOKEN: KNOCK */
+	/* rain - misc. stuff that isn't defined in the draft */
+	if (ConfigChannel.use_knock) {
+		isupport_add_token("KNOCK", &isup, maxlen, &tok);
+		if (!(isup.old_flags & ISUP_FLAG_KNOCK))
+			isupport_add_token("KNOCK", &changed, maxlen, &tok_changed);
+		isup.old_flags |= ISUP_FLAG_KNOCK;
+	} else {
+		if ((isup.old_flags & ISUP_FLAG_KNOCK))
+			isupport_add_token("-KNOCK", &changed, maxlen, &tok_changed);
+		isup.old_flags &= ~ISUP_FLAG_KNOCK;
+	}
+	
+	/* *** ISUPPORT TOKEN: VCHANS */
+	if (ConfigChannel.use_vchans) {
+		isupport_add_token("VCHANS", &isup, maxlen, &tok);
+		if (!(isup.old_flags & ISUP_FLAG_VCHANS))
+			isupport_add_token("VCHANS", &changed, maxlen, &tok_changed);
+		isup.old_flags |= ISUP_FLAG_VCHANS;
+	} else {
+		if ((isup.old_flags & ISUP_FLAG_VCHANS))
+			isupport_add_token("-VCHANS", &changed, maxlen, &tok_changed);
+		isup.old_flags &= ~ISUP_FLAG_VCHANS;
+	}
+
+	/* *** ISUPPORT TOKEN: CALLERID */
+	isupport_add_token("CALLERID=g", &isup, maxlen, &tok);
+
+
+	/* rain - these are sent for reverse compatibility (for now) */
+
+	/* *** ISUPPORT TOKEN: MAXCHANNELS */
+	sprintf(curtoken, "MAXCHANNELS=%d", ConfigChannel.max_chans_per_user);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	if (ConfigChannel.max_chans_per_user != isup.old_maxchans) {
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		isup.old_maxchans = ConfigChannel.max_chans_per_user;
+	}
+	
+	/* *** ISUPPORT TOKEN: MAXBANS */
+	sprintf(curtoken, "MAXBANS=%d", ConfigChannel.max_bans);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	if (ConfigChannel.max_bans != isup.old_maxbans) {
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		isup.old_maxbans = ConfigChannel.max_bans;
+	}
+	
+	/* *** ISUPPORT TOKEN: WALLCHOPS */
+	isupport_add_token("WALLCHOPS", &isup, maxlen, &tok);
+	
+	/* *** ISUPPORT TOKEN: MAXTARGETS */
+	sprintf(curtoken, "MAXTARGETS=%d", ConfigFileEntry.max_targets);
+	isupport_add_token(curtoken, &isup, maxlen, &tok);
+	if (ConfigFileEntry.max_targets != isup.old_maxtargets) {
+		isupport_add_token(curtoken, &changed, maxlen, &tok_changed);
+		isup.old_maxtargets = ConfigFileEntry.max_targets;
+	}
+
+	/* isup must always have at least one line */
+	isup.lines += 1;
+	/* changed might not, so check */
+	if (changed.line[0][0])
+		changed.lines += 1;
+
+	if (send_changed) {
+		DLINK_FOREACH_SAFE(dlnode, dlnode_next, lclient_list.head) {
+			client_p = dlnode->data;
+			for (x = 0; x < changed.lines; x++) {
+				sendto_one(client_p, form_str(RPL_ISUPPORT),
+					me.name, client_p->name, changed.line[x]);
+			}
+		}
+	}
+}
diff -uNrd ircd-hybrid-7.0/src/linebuf.c anynet-3.0/src/linebuf.c
--- ircd-hybrid-7.0/src/linebuf.c	Wed Oct  9 11:08:32 2002
+++ anynet-3.0/src/linebuf.c	Mon Feb  2 02:56:53 2004
@@ -630,8 +630,12 @@
  *        we have a CRLF.
  */
 int
-linebuf_flush(int fd, buf_head_t *bufhead)
+linebuf_flush(int fd, buf_head_t *bufhead, void *data)
 {
+#ifdef SSL_CLIENT_SUPPORT /* rain - only used for SSL client support */
+  struct Client *client_p = data;
+  struct LocalUser *lclient_p = client_p != NULL ? client_p->localClient : NULL;
+#endif
   buf_line_t *bufline;
   int retval;
   
@@ -660,7 +664,22 @@
     }
 
   /* Now, try writing data */
-  retval = send(fd, bufline->buf + bufhead->writeofs, bufline->len
+#ifdef SSL_CLIENT_SUPPORT
+  /* rain - handle SSL clients */
+  if (lclient_p && lclient_p->ssl_state == SSLC_STATE_CONNECTED)
+    retval = SSLC_write(client_p, bufline->buf + bufhead->writeofs,
+        bufline->len - bufhead->writeofs);
+  else if (lclient_p->ssl_state == SSLC_STATE_HANDSHAKE ||
+           lclient_p->ssl_state == SSLC_STATE_STARTTLS) {
+    /* 
+     * fake EWOULDBLOCK so that we just buffer the line until after
+     * the handshake has completed
+     */
+    errno = EWOULDBLOCK;
+    retval = -1;
+  } else
+#endif
+    retval = send(fd, bufline->buf + bufhead->writeofs, bufline->len
 		 - bufhead->writeofs, 0);
    
   /* Deal with return code */
diff -uNrd ircd-hybrid-7.0/src/list.c anynet-3.0/src/list.c
--- ircd-hybrid-7.0/src/list.c	Tue Jan 28 16:04:06 2003
+++ anynet-3.0/src/list.c	Mon Feb  2 00:54:29 2004
@@ -219,8 +219,9 @@
  * output	- NONE
  * side effects	- NONE
  */
+/* rain - made user_memory_used a u_long */
 void
-count_user_memory(int *count,int *user_memory_used)
+count_user_memory(int *count, u_long *user_memory_used)
 {
   *count = user_count;
   *user_memory_used = user_count * sizeof(struct User);
@@ -234,8 +235,9 @@
  * output	- NONE
  * side effects	- NONE
  */
+/* rain - made links_memory_used a u_long */
 void
-count_links_memory(int *count,int *links_memory_used)
+count_links_memory(int *count, u_long *links_memory_used)
 {
   *count = links_count;
   *links_memory_used = links_count * sizeof(dlink_node);
